/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace Autodesk.Forge.Model
{
    /// <summary>
    /// Advanced options for &#x60;step&#x60; type.
    /// </summary>
    [DataContract]
    public partial class JobDwgOutputPayloadAdvanced :  IEquatable<JobDwgOutputPayloadAdvanced>, IJobPayloadItemAdvanced
    {

        /// <summary>
        /// Initializes a new instance of the <see cref="JobDwgOutputPayloadAdvanced" /> class.
        /// </summary>
        [DataMember(Name= "exportSettingName", EmitDefaultValue=false)]
        public string ExportSettingName { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="JobDwgOutputPayloadAdvanced" /> class.
        /// </summary>
        /// <param name="exportSettingName">The export settings should be one of the DWG Export settings name pre-saved in the document.</param>
        public JobDwgOutputPayloadAdvanced(string exportSettingName = null)
        {
            this.ExportSettingName = exportSettingName;
        }
        
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class JobDwgOutputPayloadAdvanced {\n");
            sb.Append("  ExportSettingName: ").Append(ExportSettingName).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as JobDwgOutputPayloadAdvanced);
        }

        /// <summary>
        /// Returns true if JobStepOutputPayloadAdvanced instances are equal
        /// </summary>
        /// <param name="other">Instance of JobStepOutputPayloadAdvanced to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(JobDwgOutputPayloadAdvanced other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.ExportSettingName == other.ExportSettingName ||
                    this.ExportSettingName != null &&
                    this.ExportSettingName.Equals(other.ExportSettingName)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.ExportSettingName != null)
                    hash = hash * 59 + this.ExportSettingName.GetHashCode();
                return hash;
            }
        }
    }

}

