﻿/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace Autodesk.Forge.Model
{
    /// <summary>
    /// Destination region
    /// </summary>
    [DataContract]
    public partial class JobPayloadDestination :  IEquatable<JobPayloadDestination>
    {
        [JsonConverter(typeof(StringEnumConverter))]
        public enum RegionEnum
        {
            /// <summary>
            /// Enum US for us
            /// </summary>
            [EnumMember(Value = "us")]
            US,
            
            /// <summary>
            /// Enum EMEA for emea
            /// </summary>
            [EnumMember(Value = "emea")]
            EMEA
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="JobPayloadDestination" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected JobPayloadDestination() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="JobPayloadDestination" /> class.
        /// </summary>
        /// <param name="region">Region in which to store outputs. Possible values: US, EMEA. By default, it is set to US.</param>
        public JobPayloadDestination(RegionEnum? region = null)
        {
            if (region == null)
            {
              throw new InvalidDataException("Region is a required property for JobPayloadDestination and cannot be null");
            }
            else
            {
              this.Region = region;
            }
        }
        
        /// <summary>
        /// Region in which to store outputs. 
        /// </summary>
        /// <value>Region in which to store outputs. Possible values: US, EMEA. By default, it is set to US.. </value>
        [DataMember(Name="region", EmitDefaultValue=false)]
        public RegionEnum? Region { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class JobPayloaDestination {\n");
            sb.Append("  Region: ").Append(Region).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as JobPayloadMisc);
        }

        /// <summary>
        /// Returns true if JobPayloadMisc instances are equal
        /// </summary>
        /// <param name="other">Instance of JobPayloadMisc to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(JobPayloadDestination other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Region == other.Region ||
                    this.Region != null &&
                    this.Region.Equals(other.Region)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Region != null)
                    hash = hash * 59 + this.Region.GetHashCode();
                return hash;
            }
        }
    }

}

