/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace Autodesk.Forge.Model
{
    /// <summary>
    /// metadata collection definition
    /// </summary>
    [DataContract]
    public partial class MetadataCollection :  IEquatable<MetadataCollection>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MetadataCollection" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected MetadataCollection() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="MetadataCollection" /> class.
        /// </summary>
        /// <param name="Objectid">Unique ID for the object (required).</param>
        /// <param name="Name">Name of the object (required).</param>
        /// <param name="Properties">Represents the object’s “properties”.</param>
        public MetadataCollection(int? Objectid = null, string Name = null, Object Properties = null)
        {
            // to ensure "Objectid" is required (not null)
            if (Objectid == null)
            {
                throw new InvalidDataException("Objectid is a required property for MetadataCollection and cannot be null");
            }
            else
            {
                this.Objectid = Objectid;
            }
            // to ensure "Name" is required (not null)
            if (Name == null)
            {
                throw new InvalidDataException("Name is a required property for MetadataCollection and cannot be null");
            }
            else
            {
                this.Name = Name;
            }
            this.Properties = Properties;
        }
        
        /// <summary>
        /// Unique ID for the object
        /// </summary>
        /// <value>Unique ID for the object</value>
        [DataMember(Name="objectid", EmitDefaultValue=false)]
        public int? Objectid { get; set; }
        /// <summary>
        /// Name of the object
        /// </summary>
        /// <value>Name of the object</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }
        /// <summary>
        /// Represents the object’s “properties”
        /// </summary>
        /// <value>Represents the object’s “properties”</value>
        [DataMember(Name="properties", EmitDefaultValue=false)]
        public Object Properties { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MetadataCollection {\n");
            sb.Append("  Objectid: ").Append(Objectid).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Properties: ").Append(Properties).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as MetadataCollection);
        }

        /// <summary>
        /// Returns true if MetadataCollection instances are equal
        /// </summary>
        /// <param name="other">Instance of MetadataCollection to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(MetadataCollection other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Objectid == other.Objectid ||
                    this.Objectid != null &&
                    this.Objectid.Equals(other.Objectid)
                ) && 
                (
                    this.Name == other.Name ||
                    this.Name != null &&
                    this.Name.Equals(other.Name)
                ) && 
                (
                    this.Properties == other.Properties ||
                    this.Properties != null &&
                    this.Properties.Equals(other.Properties)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Objectid != null)
                    hash = hash * 59 + this.Objectid.GetHashCode();
                if (this.Name != null)
                    hash = hash * 59 + this.Name.GetHashCode();
                if (this.Properties != null)
                    hash = hash * 59 + this.Properties.GetHashCode();
                return hash;
            }
        }
    }

}

