/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace Autodesk.Forge.Model
{
    /// <summary>
    /// Object Signed Object json response
    /// </summary>
    [DataContract]
    public partial class PostObjectSigned :  IEquatable<PostObjectSigned>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PostObjectSigned" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PostObjectSigned() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PostObjectSigned" /> class.
        /// </summary>
        /// <param name="SignedUrl">URL created for downloading the object (required).</param>
        /// <param name="Expiration">Value for expiration in minutes (required).</param>
        public PostObjectSigned(string SignedUrl = null, long? Expiration = null)
        {
            // to ensure "SignedUrl" is required (not null)
            if (SignedUrl == null)
            {
                throw new InvalidDataException("SignedUrl is a required property for PostObjectSigned and cannot be null");
            }
            else
            {
                this.SignedUrl = SignedUrl;
            }
            // to ensure "Expiration" is required (not null)
            if (Expiration == null)
            {
                throw new InvalidDataException("Expiration is a required property for PostObjectSigned and cannot be null");
            }
            else
            {
                this.Expiration = Expiration;
            }
        }
        
        /// <summary>
        /// URL created for downloading the object
        /// </summary>
        /// <value>URL created for downloading the object</value>
        [DataMember(Name="signedUrl", EmitDefaultValue=false)]
        public string SignedUrl { get; set; }
        /// <summary>
        /// Value for expiration in minutes
        /// </summary>
        /// <value>Value for expiration in minutes</value>
        [DataMember(Name="expiration", EmitDefaultValue=false)]
        public long? Expiration { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PostObjectSigned {\n");
            sb.Append("  SignedUrl: ").Append(SignedUrl).Append("\n");
            sb.Append("  Expiration: ").Append(Expiration).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as PostObjectSigned);
        }

        /// <summary>
        /// Returns true if PostObjectSigned instances are equal
        /// </summary>
        /// <param name="other">Instance of PostObjectSigned to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PostObjectSigned other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.SignedUrl == other.SignedUrl ||
                    this.SignedUrl != null &&
                    this.SignedUrl.Equals(other.SignedUrl)
                ) && 
                (
                    this.Expiration == other.Expiration ||
                    this.Expiration != null &&
                    this.Expiration.Equals(other.Expiration)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.SignedUrl != null)
                    hash = hash * 59 + this.SignedUrl.GetHashCode();
                if (this.Expiration != null)
                    hash = hash * 59 + this.Expiration.GetHashCode();
                return hash;
            }
        }
    }

}

