/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace Autodesk.Forge.Model
{
    /// <summary>
    /// VersionRelationships
    /// </summary>
    [DataContract]
    public partial class VersionRelationships :  IEquatable<VersionRelationships>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="VersionRelationships" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected VersionRelationships() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="VersionRelationships" /> class.
        /// </summary>
        /// <param name="Item">Item (required).</param>
        /// <param name="Refs">Refs (required).</param>
        /// <param name="Storage">Storage.</param>
        /// <param name="Derivatives">Derivatives.</param>
        /// <param name="Thumbnails">Thumbnails.</param>
        public VersionRelationships(JsonApiRelationshipsLinksInternalResource Item = null, JsonApiRelationshipsLinksRefs Refs = null, JsonApiRelationshipsLinksExternalResource Storage = null, JsonApiRelationshipsLinksExternalResource Derivatives = null, JsonApiRelationshipsLinksExternalResource Thumbnails = null)
        {
            // to ensure "Item" is required (not null)
            if (Item == null)
            {
                throw new InvalidDataException("Item is a required property for VersionRelationships and cannot be null");
            }
            else
            {
                this.Item = Item;
            }
            // to ensure "Refs" is required (not null)
            if (Refs == null)
            {
                throw new InvalidDataException("Refs is a required property for VersionRelationships and cannot be null");
            }
            else
            {
                this.Refs = Refs;
            }
            this.Storage = Storage;
            this.Derivatives = Derivatives;
            this.Thumbnails = Thumbnails;
        }
        
        /// <summary>
        /// Gets or Sets Item
        /// </summary>
        [DataMember(Name="item", EmitDefaultValue=false)]
        public JsonApiRelationshipsLinksInternalResource Item { get; set; }
        /// <summary>
        /// Gets or Sets Refs
        /// </summary>
        [DataMember(Name="refs", EmitDefaultValue=false)]
        public JsonApiRelationshipsLinksRefs Refs { get; set; }
        /// <summary>
        /// Gets or Sets Storage
        /// </summary>
        [DataMember(Name="storage", EmitDefaultValue=false)]
        public JsonApiRelationshipsLinksExternalResource Storage { get; set; }
        /// <summary>
        /// Gets or Sets Derivatives
        /// </summary>
        [DataMember(Name="derivatives", EmitDefaultValue=false)]
        public JsonApiRelationshipsLinksExternalResource Derivatives { get; set; }
        /// <summary>
        /// Gets or Sets Thumbnails
        /// </summary>
        [DataMember(Name="thumbnails", EmitDefaultValue=false)]
        public JsonApiRelationshipsLinksExternalResource Thumbnails { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class VersionRelationships {\n");
            sb.Append("  Item: ").Append(Item).Append("\n");
            sb.Append("  Refs: ").Append(Refs).Append("\n");
            sb.Append("  Storage: ").Append(Storage).Append("\n");
            sb.Append("  Derivatives: ").Append(Derivatives).Append("\n");
            sb.Append("  Thumbnails: ").Append(Thumbnails).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as VersionRelationships);
        }

        /// <summary>
        /// Returns true if VersionRelationships instances are equal
        /// </summary>
        /// <param name="other">Instance of VersionRelationships to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(VersionRelationships other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Item == other.Item ||
                    this.Item != null &&
                    this.Item.Equals(other.Item)
                ) && 
                (
                    this.Refs == other.Refs ||
                    this.Refs != null &&
                    this.Refs.Equals(other.Refs)
                ) && 
                (
                    this.Storage == other.Storage ||
                    this.Storage != null &&
                    this.Storage.Equals(other.Storage)
                ) && 
                (
                    this.Derivatives == other.Derivatives ||
                    this.Derivatives != null &&
                    this.Derivatives.Equals(other.Derivatives)
                ) && 
                (
                    this.Thumbnails == other.Thumbnails ||
                    this.Thumbnails != null &&
                    this.Thumbnails.Equals(other.Thumbnails)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Item != null)
                    hash = hash * 59 + this.Item.GetHashCode();
                if (this.Refs != null)
                    hash = hash * 59 + this.Refs.GetHashCode();
                if (this.Storage != null)
                    hash = hash * 59 + this.Storage.GetHashCode();
                if (this.Derivatives != null)
                    hash = hash * 59 + this.Derivatives.GetHashCode();
                if (this.Thumbnails != null)
                    hash = hash * 59 + this.Thumbnails.GetHashCode();
                return hash;
            }
        }
    }

}

